// This File is part of the "nyaqt" Project
// 
// Copyright  2009 sometmes@gmail.com
// All rights reserved
// 
// This library is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation; either version 2.1 of the License, or
// (at your option) any later version.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Notify2
{
    public partial class SendToGmailOptionsForm : Form
    {
        public bool AskForImages = true;
        public bool AskForMultipleEmail;


        internal ImageSizeOption SelectedImageSize
        {
            get
            {
                if (keepOriginalSizeCheckBox.Checked)
                    return Enums.ImageSizeOptionKeepOriginal;
                else
                    return imageSizeComboBox.SelectedItem as ImageSizeOption;
            }
        }

        internal bool KeepOriginalSize
        {
            get
            {
                return keepOriginalSizeCheckBox.Checked;
            }
        }

        public SendToGmailOptionsForm()
        {
            InitializeComponent();
        }

        private void SendToGmailOptionsForm_Load(object sender, EventArgs e)
        {
            label1.Visible = AskForImages;
            imageSizeComboBox.Visible = AskForImages;
            keepOriginalSizeCheckBox.Visible = AskForImages;

            allowMultipleEmailCheckBox.Visible = false;
            //allowMultipleEmailCheckBox.Visible = AskForMultipleEmail;

            //if (!AskForImages)
            //    allowMultipleEmailCheckBox.Top = keepOriginalSizeCheckBox.Top;

            imageSizeComboBox.Items.Clear();
            imageSizeComboBox.Items.Add(Enums.ImageSizeOption640);
            imageSizeComboBox.Items.Add(Enums.ImageSizeOption800);
            imageSizeComboBox.Items.Add(Enums.ImageSizeOption1024);
            string defaultImageSize = Properties.Settings.Default.DefaultImageSize;
            keepOriginalSizeCheckBox.Checked = (defaultImageSize == Enums.ImageSizeOptionKeepOriginal.Id);
            foreach (ImageSizeOption option2 in imageSizeComboBox.Items)
                if (option2.Id == defaultImageSize)
                    imageSizeComboBox.SelectedItem = option2;
            imageSizeComboBox.Enabled = !keepOriginalSizeCheckBox.Checked;
        }

        private void oKButton_Click(object sender, EventArgs e)
        {
            if (AskForMultipleEmail && !allowMultipleEmailCheckBox.Checked)
                this.DialogResult = DialogResult.Abort;
            else
                this.DialogResult = DialogResult.OK;
        }

        private void keepOriginalSizeCheckBox_CheckedChanged(object sender, EventArgs e)
        {
            imageSizeComboBox.Enabled = !keepOriginalSizeCheckBox.Checked;
        }
    }
}
