using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using IWshRuntimeLibrary;
using System.Resources;
using System.Reflection;
using System.Diagnostics;
using System.Runtime.InteropServices;
using System.Collections;
using System.Threading;
using Microsoft.Win32;

namespace Notify2
{
    public partial class SetupUninstallForm : Form
    {
        private string wrongSetupPath = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData), "GmailNotifier2");

        public SetupUninstallForm()
        {
            InitializeComponent();
        }

        private void SetupForm_Load(object sender, EventArgs e)
        {
            setupPathTextbox.Text = My.Resources.WillDeleteFiles + "  \"" + Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData), "GmailNotifier2") + "\"";
        }

        private void cancelButton_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void installButton_Click(object sender, EventArgs e)
        {
            try
            {
                SetupForm.ShutdownNotifierProcesses();
                RegistryKey key;
                using (key = Registry.ClassesRoot.OpenSubKey(@"*\shell", true))
                {
                    if (key != null)
                    {
                        string keyname;
                        keyname = "Send To Gmail - Blue";
                        if (key.OpenSubKey(keyname) != null)
                            key.DeleteSubKeyTree(keyname);
                        keyname = "Send To Gmail - Green";
                        if (key.OpenSubKey(keyname) != null)
                            key.DeleteSubKeyTree(keyname);
                        keyname = "Send To Gmail - Pink";
                        if (key.OpenSubKey(keyname) != null)
                            key.DeleteSubKeyTree(keyname);
                    }
                }
                using (key = Registry.CurrentUser.OpenSubKey(@"Software\Microsoft\Windows\CurrentVersion\Run", true))
                {
                    key.DeleteValue("GmailNotifier2-Blue", false);
                    key.DeleteValue("GmailNotifier2-Green", false);
                    key.DeleteValue("GmailNotifier2-Pink", false);
                }
                using (key = Registry.CurrentUser.OpenSubKey(@"Software\Microsoft\Windows\CurrentVersion\Uninstall", true))
                {
                    string keyname = "Gmail Notifier 2";
                    if (key.OpenSubKey(keyname) != null)
                        key.DeleteSubKeyTree(keyname);
                }
                SetupUtils.DeleteDirectory(SetupForm.notifierGroup);
                string userconfig = Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData);
                userconfig = Path.Combine(userconfig, "sometmes@gmail.com");
                if (Directory.Exists(userconfig))
                {
                    string[] dirs = Directory.GetDirectories(userconfig, "GmailNotifier2.EXE_*");
                    foreach (string dir in dirs)
                    {
                        SetupUtils.DeleteDirectory(dir);
                    }
                }
                SetupUtils.DeleteDirectory(this.wrongSetupPath);
                SetupUtils.DeleteDirectory(SetupForm.setupPath);
                MessageBox.Show("Uninstall finished.", "Uninstall", MessageBoxButtons.OK);
                Application.Exit();
            }
            catch (Exception ex)
            {
                Exception baseex = ex.GetBaseException();
                string msg = baseex.Message;
                foreach (IDictionaryEnumerator enumdata in baseex.Data)
                    msg += "\r\n" + enumdata.Key + ": " + enumdata.Value;
                MessageBox.Show(msg);
            }
        }
    }
}